#ifndef __breakout_h__
#define __breakout_h__

#include "vector.h"

// Structs
typedef struct ballStruct {
    Vector Location, Momentum;
    SDL_Rect TargetRect;
    double Size, Rotation, RotationValue;
    int TextureIndex;
} Ball; // Objekt für die Eigenschaften des Balls

typedef struct paddleStruct {
    double XLocation; // Notice: Locked Y-Coordinate
    SDL_Rect TargetRect;
    int XSize, TextureIndex;
} Paddle; // Objekt für die Eigenschaften des Paddles

typedef struct blockStruct {
    Vector Location;
    SDL_Rect TargetRect;
    int XSize, YSize, TextureIndex;
} Block; // Objekt für die Eigenschaften des Paddles
// End Structs

// Prototypes
void BREAKOUT_INITIALIZE(SDL_Renderer * renderer, int width, int height);
void BREAKOUT_Update(Uint8 * keystate);
void BREAKOUT_Draw(SDL_Renderer * renderer);
void BREAKOUT_DEINITIALIZE();
void BALL_Initialize(SDL_Renderer * renderer);
Ball BALL_CreateDefault();
void BALL_Draw(SDL_Renderer * renderer, Ball * obj);
void BALL_Update(Ball * obj);
void BALL_DestroyObject(Ball * obj);
void BALL_Deinitialize();
// End Prototypes

#endif // __breakout_h__
